"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = deepMap;

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

function deepMapCached(obj, f, ctx, cache) {
  cache.push(obj);

  if (Array.isArray(obj)) {
    return obj.map(function (val, key) {
      val = f.call(ctx, val, key);
      return (0, _typeof2["default"])(val) === 'object' && cache.indexOf(val) === -1 ? deepMapCached(val, f, ctx, cache) : val;
    });
  } else if ((0, _typeof2["default"])(obj) === 'object') {
    var res = {};

    for (var key in obj) {
      var val = obj[key];

      if (val && (0, _typeof2["default"])(val) === 'object') {
        val = f.call(ctx, val, key);
        res[key] = cache.indexOf(val) === -1 ? deepMapCached(val, f, ctx, cache) : val;
      } else {
        res[key] = f.call(ctx, val, key);
      }
    }

    return res;
  } else {
    return obj;
  }
}

function deepMap(obj, f, ctx) {
  return deepMapCached(obj, f, ctx, []);
}